/****************************************************************************************** 
 *	Chili DirectX Framework Version 12.04.24											  *	
 *	Game.cpp																			  *
 *	Copyright 2012 PlanetChili.net														  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#include "Game.h"
#include "Bitmap.h"
#include "Images.h"

Game::Game( HWND hWnd,const KeyboardServer& kServer,const MouseServer& mServer )
:	gfx( hWnd ),
	audio( hWnd ),
	kbd( kServer ),
	mouse( mServer ),
	x ( 400 ),
	y ( 400),
	keypressedlastframe ( false ),
	missilecount ( 0 )
{
fire = audio.CreateSound( "gun2.wav" );

LoadBmp("WalkinDude\\wdude00.bmp",surface);
LoadBmp("Scanner.bmp",surface);
}
void Game::Crosshair(int x,int y)
{
	gfx.PutPixelClipped(x,y,255,0,0);
	
	gfx.PutPixelClipped(x+2,y+2,255,0,0);
	gfx.PutPixelClipped(x+3,y+3,255,0,0);
	gfx.PutPixelClipped(x+4,y+4,255,0,0);
	gfx.PutPixelClipped(x+5,y+5,255,0,0);
	gfx.PutPixelClipped(x+6,y+6,255,0,0);

	gfx.PutPixelClipped(x-2,y+2,255,0,0);
	gfx.PutPixelClipped(x-3,y+3,255,0,0);
	gfx.PutPixelClipped(x-4,y+4,255,0,0);
	gfx.PutPixelClipped(x-5,y+5,255,0,0);
	gfx.PutPixelClipped(x-6,y+6,255,0,0);

	gfx.PutPixelClipped(x-2,y-2,255,0,0);
	gfx.PutPixelClipped(x-3,y-3,255,0,0);
	gfx.PutPixelClipped(x-4,y-4,255,0,0);
	gfx.PutPixelClipped(x-5,y-5,255,0,0);
	gfx.PutPixelClipped(x-6,y-6,255,0,0);

	gfx.PutPixelClipped(x+2,y-2,255,0,0);
	gfx.PutPixelClipped(x+3,y-3,255,0,0);
	gfx.PutPixelClipped(x+4,y-4,255,0,0);
	gfx.PutPixelClipped(x+5,y-5,255,0,0);
	gfx.PutPixelClipped(x+6,y-6,255,0,0);
}

void Game::Go()
{
	gfx.BeginFrame();
	ComposeFrame();
	gfx.EndFrame();
}

void Game::ComposeFrame()
{

gfx.DrawSurface(0,0,800,600,surface);
// This code here increases the missile every time left mouse key is depressed. However it is supposed to wait until mouse key is released first.

if (mouse.IsInWindow() && mouse.LeftIsPressed() && !Missile[missilecount].Fired && !keypressedlastframe)
	{
		//sound
		fire.Play();
		Missile[missilecount].FireMissile(true,mouse.GetMouseX(),mouse.GetMouseY() );
		missilecount++;
			
		if (missilecount>=NOM)
			{
				missilecount=0;
			}
		keypressedlastframe=true;
	}		
	else
		{
			keypressedlastframe=false;
		}

		char buf[2048];
sprintf(buf,"key pressed last frame is %d\n",keypressedlastframe);
OutputDebugStringA(buf);

// Draws and moves all missiles
for (int mcount=0; mcount<NOM; mcount++)
{
		Missile[mcount].UpdateMissile(&gfx);
		Missile[mcount].DrawMissile(&gfx);
		Missile[mcount].ExplosionUpdate(&gfx);
}	


if (mouse.IsInWindow())
{
	Crosshair(mouse.GetMouseX(),mouse.GetMouseY());
}	



}